#ifndef _ygNodeDB_h_
#define _ygNodeDB_h_

#include <vector>
#include <map>
#include "ygString.h"
class ygNode;
class ygTokenStream;


class ygNodeDB
    {
    public:
     static void init(void);
     static ygNode* find(const ygString& name, bool connect=true);
     static bool createValidName(const ygString& nodeType,ygString& name);
     static ygNode* create(const ygString& ntype, const ygString& name,
                    ygTokenStream *ts=NULL);
     static void remove(ygNode* node);
     static ygNode* createProxy(const ygString&, const ygString&);
     static const std::vector<ygNode*>& nodesOfType(const ygString& nodeType);
    private:
     static struct _ygNodeDBPrivateData * p_;
    };


#endif
